SystemOrganization addCategory: #'Creole-Parsing'!
SystemOrganization addCategory: #'Creole-Nodes'!
SystemOrganization addCategory: #'Creole-Visitors'!
SystemOrganization addCategory: #'Creole-Tests'!

Notification subclass: #InCreoleTable
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Creole-Parsing'!

!InCreoleTable methodsFor: 'as yet unclassified' stamp: 'cwp 1/7/2009 21:18'!
defaultAction
	^ self resume: false! !

Notification subclass: #InCreoleUnorderedList
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Creole-Parsing'!

!InCreoleUnorderedList class methodsFor: 'as yet unclassified' stamp: 'cwp 1/7/2009 19:36'!
not
	^ self signal not! !

!InCreoleUnorderedList methodsFor: 'as yet unclassified' stamp: 'cwp 1/7/2009 18:23'!
defaultAction
	^ self resume: false! !

Object subclass: #AbstractCreoleParser
	instanceVariableNames: 'in'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Creole-Parsing'!

!AbstractCreoleParser class methodsFor: 'as yet unclassified' stamp: 'cwp 1/6/2009 15:24'!
on: aStream
	^ self new setStream: aStream! !

!AbstractCreoleParser class methodsFor: 'as yet unclassified' stamp: 'cwp 1/6/2009 15:24'!
parse: aString
	^ (self on: aString readStream) parse! !

!AbstractCreoleParser class methodsFor: 'as yet unclassified' stamp: 'cwp 1/6/2009 15:24'!
parseFrom: aStream
	^ (self on: aStream) parse! !

!AbstractCreoleParser methodsFor: 'parsing' stamp: 'cwp 1/7/2009 11:45'!
checkFor: aCharacter
	| char |
	char := in next.
	char = aCharacter ifFalse: 
		[self error: 'Expected ', aCharacter printString, ' but encountered ' , char printString]! !

!AbstractCreoleParser methodsFor: 'parsing' stamp: 'cwp 1/7/2009 11:11'!
createBacktrack
	| position |
	position := in position.
	^ [in position: position]! !

!AbstractCreoleParser methodsFor: 'look ahead' stamp: 'cwp 1/7/2009 11:26'!
createBacktrack: aBlock
	| position |
	position := in position.
	^ 	[in position: position.
	  	aBlock value]! !

!AbstractCreoleParser methodsFor: 'as yet unclassified' stamp: 'cwp 1/6/2009 18:56'!
createOutputStream
	^ (String new: 10) writeStream! !

!AbstractCreoleParser methodsFor: 'look ahead' stamp: 'cwp 1/7/2009 18:01'!
hasBlockTerminator
	^ [self isBlockTerminator: in next]
		ensure: [in back]! !

!AbstractCreoleParser methodsFor: 'look ahead' stamp: 'cwp 1/10/2009 13:35'!
isBlockTerminator: first
	| yes no second third fourth |
	yes := self createBacktrack: [^ true].
	no := self createBacktrack: [^ false].
	
	first isLineEnd ifFalse: no.
	second := in next.
	second ifNil: yes.				"end of input"
	second isLineEnd ifTrue: yes.	"paragraph break"
	second = $= ifTrue: yes.			"heading"
	second = $# ifTrue: yes.			"ordered list"
	
	"unordered list, complicated by bold markup."
	third := in next.
	fourth := in next.	
	second = $* ifTrue:
		[fourth = $* ifTrue: yes.
		third = $* 
			ifTrue: [InCreoleUnorderedList signal ifTrue: yes ifFalse: no]
			ifFalse: yes].
	
	"start of nowiki block"
	(second = ${ and: [third = ${] and: [fourth = ${]) ifTrue: yes.
	
	no value! !

!AbstractCreoleParser methodsFor: 'parsing' stamp: 'cwp 1/6/2009 15:22'!
parse
	self subclassResponsibility! !

!AbstractCreoleParser methodsFor: 'as yet unclassified' stamp: 'cwp 1/7/2009 12:20'!
parseBackslash
	^ in peek = $\
		ifTrue: 
			[in skip: 1.
			CreoleBreakNode new]
		ifFalse: 
			[in back.
			CreoleTextParser parseFrom: in]! !

!AbstractCreoleParser methodsFor: 'parsing' stamp: 'cwp 1/6/2009 16:17'!
parseChildrenOf: aParentNode until: aBlock
	[in atEnd or: aBlock] whileFalse:
		[aParentNode addChild: self parseNode].
	^ aParentNode! !

!AbstractCreoleParser methodsFor: 'parsing' stamp: 'cwp 1/6/2009 16:35'!
parseText
	in back.
	^ CreoleTextParser parseFrom: in! !

!AbstractCreoleParser methodsFor: 'as yet unclassified' stamp: 'cwp 1/6/2009 19:16'!
parseWith: aParserClass on: aCharacter
	^ in peek = aCharacter
		ifTrue: [aParserClass parseFrom: in]
		ifFalse: 
			[in back.
			CreoleTextParser parseFrom: in]! !

!AbstractCreoleParser methodsFor: 'peeking' stamp: 'cwp 1/6/2009 16:27'!
peekFor: first and: second
	^ self peekTwo: [:one :two | one = first and: [two = second]]! !

!AbstractCreoleParser methodsFor: 'peeking' stamp: 'cwp 1/7/2009 18:34'!
peekTwo: aBlock
	^ [aBlock value: in next value: in next]
		ensure: self createBacktrack.! !

!AbstractCreoleParser methodsFor: 'initialize-release' stamp: 'cwp 1/6/2009 15:22'!
setStream: aStream
	in := aStream! !

!AbstractCreoleParser methodsFor: 'as yet unclassified' stamp: 'cwp 1/6/2009 18:03'!
skipWhitespace
	| char |
	char := in peek.
	[char notNil and: [char isSeparator]] whileTrue: 
		[in skip: 1.
		char := in peek]! !

AbstractCreoleParser subclass: #CreoleBlockContentParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Creole-Parsing'!

!CreoleBlockContentParser methodsFor: 'as yet unclassified' stamp: 'cwp 1/7/2009 12:16'!
hasTerminator
	^ self hasBlockTerminator! !

!CreoleBlockContentParser methodsFor: 'as yet unclassified' stamp: 'cwp 1/7/2009 14:59'!
parse
	| node |
	node := self createNode.
	self 
		parseChildrenOf: node
		until: [ self hasTerminator ].
	self skipTerminator.
	^ node! !

!CreoleBlockContentParser methodsFor: 'as yet unclassified' stamp: 'cwp 1/7/2009 13:14'!
parseNode
	| char |
	char := in next.
	char = $* ifTrue: [^ self parseWith: CreoleBoldParser on: $*].
	char = $/ ifTrue: [^ self parseWith: CreoleItalicParser on: $/].
	char = $[ ifTrue: [^ self parseWith: CreoleLinkParser on: $[].
	char = ${ ifTrue: [^ self parseOpeningBrace].
	char = $\ ifTrue: [^ self parseBackslash].
	^ self parseText! !

!CreoleBlockContentParser methodsFor: 'as yet unclassified' stamp: 'cwp 1/7/2009 13:25'!
parseOpeningBrace
	^ in peek = ${
		ifTrue: 
			[in skip: 1.
			in peek = ${
				ifTrue: [CreoleInlineNowikiParser parseFrom: in]
				ifFalse: [CreoleImageParser parseFrom: in]]
		ifFalse: 
			[in back.
			CreoleTextParser parseFrom: in]
		
		! !

!CreoleBlockContentParser methodsFor: 'as yet unclassified' stamp: 'cwp 1/7/2009 01:46'!
skipTerminator
	self skipWhitespace! !

CreoleBlockContentParser subclass: #CreoleListItemParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Creole-Parsing'!

!CreoleListItemParser methodsFor: 'as yet unclassified' stamp: 'cwp 1/7/2009 01:33'!
createNode
	^ CreoleItemNode new! !

!CreoleListItemParser methodsFor: 'as yet unclassified' stamp: 'cwp 1/7/2009 14:59'!
hasTerminator
	| yes no second third fourth |
	yes := self createBacktrack: [^ true].
	no := self createBacktrack: [^ false].
	
	in next isLineEnd ifFalse: no.
	second := in next.
	second isLineEnd ifTrue: yes.
	second = $= ifTrue: yes.
	second = $# ifTrue: yes.
	second = $* ifTrue: yes.
	
	third := in next.
	fourth := in next.
	(second = ${ and: [third = ${] and: [fourth = ${]) ifTrue: yes.
	
	no value! !

CreoleBlockContentParser subclass: #CreoleParagraphParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Creole-Parsing'!

!CreoleParagraphParser methodsFor: 'as yet unclassified' stamp: 'cwp 1/7/2009 01:13'!
createNode
	^ CreoleParagraphNode new! !

AbstractCreoleParser subclass: #CreoleBoldParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Creole-Parsing'!

!CreoleBoldParser methodsFor: 'as yet unclassified' stamp: 'cwp 1/7/2009 01:51'!
hasTerminator
	^ (self 
		peekFor: $*
		and: $*) or: [ self hasBlockTerminator ]! !

!CreoleBoldParser methodsFor: 'as yet unclassified' stamp: 'cwp 1/6/2009 16:53'!
parse
	| bold |
	self checkFor: $*.
	bold := CreoleBoldNode new.
	self 
		parseChildrenOf: bold
		until: [ self hasTerminator ].
	self skipTerminator.
	^ bold! !

!CreoleBoldParser methodsFor: 'as yet unclassified' stamp: 'cwp 1/6/2009 19:17'!
parseNode
	| char |
	char := in next.
	char = $/ ifTrue: [^ self parseWith: CreoleItalicParser on: $/].
	char = $[ ifTrue: [^ self parseWith: CreoleLinkParser on: $[].
	^ self parseText! !

!CreoleBoldParser methodsFor: 'as yet unclassified' stamp: 'cwp 1/6/2009 16:53'!
skipTerminator
	in peekFor: $*.
	in peekFor: $*! !

AbstractCreoleParser subclass: #CreoleDocumentParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Creole-Parsing'!

!CreoleDocumentParser methodsFor: 'parsing' stamp: 'cwp 1/7/2009 18:55'!
hasBoldParagraph
	
	| yes no |
	"If we're already in a list, then this is a sublist"
	InCreoleUnorderedList signal ifTrue: [ ^ false ].
	
	yes := self createBacktrack: [^ true ].
	no := self createBacktrack: [^ false].
	in next = $* ifFalse: no.		"No stars, can't be bold"
	in next = $* ifFalse: no.		"Only one star, can't be bold"
	in next = $* ifTrue: no.		"Three or more stars, can't be bold"
	
	yes value. 					"If we got here, it *is* bold"! !

!CreoleDocumentParser methodsFor: 'parsing' stamp: 'cwp 1/6/2009 17:56'!
parse
	| nodes |
	nodes := OrderedCollection new.
	[in atEnd] whileFalse: [nodes add: self parseBlock].
	^ nodes size = 1
		ifTrue: [nodes anyOne]
		ifFalse: [CreoleParentNode withAll: nodes]
		! !

!CreoleDocumentParser methodsFor: 'parsing' stamp: 'cwp 1/7/2009 22:32'!
parseBlock
	| char |
	self skipWhitespace.
	char := in peek.
	char = $= ifTrue: [ ^ self parseHeading ].
	char = $* ifTrue: [ ^ self parseUnorderedList ].
	char = $# ifTrue: [ ^ self parseOrderedList ].
	char = $- ifTrue: [ ^ self parseRule ].
	char = ${ ifTrue: [ ^ self parseOpeningBrace ].
	char = $| ifTrue: [ ^ self parseTable ].
	^ self parseParagraph! !

!CreoleDocumentParser methodsFor: 'parsing' stamp: 'cwp 1/6/2009 17:59'!
parseHeading
	^ CreoleHeadingParser parseFrom: in! !

!CreoleDocumentParser methodsFor: 'parsing' stamp: 'cwp 1/7/2009 22:32'!
parseOpeningBrace
	"A nowiki block starts with {{{ on a single line, otherwise this is a paragraph"
	| bail |
	bail := self createBacktrack: [ ^ self parseParagraph ].
	3 timesRepeat: [ in next = ${ ifFalse: bail ].
	in next isLineEnd ifFalse: bail.
	^ CreoleBlockNowikiParser parseFrom: in! !

!CreoleDocumentParser methodsFor: 'parsing' stamp: 'cwp 1/7/2009 10:47'!
parseOrderedList
	^ CreoleListParser parseFrom: in! !

!CreoleDocumentParser methodsFor: 'parsing' stamp: 'cwp 1/6/2009 15:27'!
parseParagraph
	^ CreoleParagraphParser parseFrom: in! !

!CreoleDocumentParser methodsFor: 'parsing' stamp: 'cwp 1/7/2009 11:35'!
parseRule
	| backtrack char |
	backtrack := self createBacktrack: [^ self parseParagraph].
	4 timesRepeat: [in next = $- ifFalse: backtrack].
	char := in next.
	[char isNil or: [char isLineEnd]] whileFalse:
		[char isSeparator ifFalse: backtrack.
		char := in next].
	self skipWhitespace.
	^ CreoleRuleNode new! !

!CreoleDocumentParser methodsFor: 'parsing' stamp: 'cwp 1/7/2009 20:17'!
parseTable
	^ CreoleTableParser parseFrom: in! !

!CreoleDocumentParser methodsFor: 'parsing' stamp: 'cwp 1/7/2009 18:31'!
parseUnorderedList
	"Two stars could mean a paragraph that starts with bold text, so check for that."

	^ self hasBoldParagraph
		ifTrue: [self parseParagraph]
		ifFalse: [CreoleListParser parseFrom: in]
! !

AbstractCreoleParser subclass: #CreoleHeadingParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Creole-Parsing'!

!CreoleHeadingParser methodsFor: 'as yet unclassified' stamp: 'cwp 1/6/2009 18:05'!
hasTerminator
	| char |
	char := in peek.
	^ char isNil or: [char isLineEnd or: [char = $=]]! !

!CreoleHeadingParser methodsFor: 'as yet unclassified' stamp: 'cwp 1/6/2009 18:03'!
parse
	| level text |
	level := self parseLevel.
	self skipWhitespace.
	text := self parseText.
	self skipTrailingLevel.
	^ CreoleHeadingNode level: level text: text.! !

!CreoleHeadingParser methodsFor: 'as yet unclassified' stamp: 'cwp 1/6/2009 18:02'!
parseLevel
	| level char |
	level := 0.
	char := in next.
	[char = $=] whileTrue:
		[level := level + 1.
		char := in next].
	^ level! !

!CreoleHeadingParser methodsFor: 'as yet unclassified' stamp: 'cwp 1/6/2009 18:56'!
parseText
	| out |
	out := self createOutputStream.
	[ self hasTerminator ] whileFalse: [ out nextPut: in next ].
	^ out contents! !

!CreoleHeadingParser methodsFor: 'as yet unclassified' stamp: 'cwp 1/6/2009 18:18'!
skipTrailingLevel 
	| char |
	[char := in peek.
	char isNil or: [char isLineEnd]] whileFalse: 
		[in skip: 1]! !

AbstractCreoleParser subclass: #CreoleItalicParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Creole-Parsing'!

!CreoleItalicParser methodsFor: 'as yet unclassified' stamp: 'cwp 1/7/2009 01:51'!
hasTerminator
	^ (self 
		peekFor: $/
		and: $/) or: [ self hasBlockTerminator ]! !

!CreoleItalicParser methodsFor: 'as yet unclassified' stamp: 'cwp 1/6/2009 16:52'!
parse
	| bold |
	self checkFor: $/.
	bold := CreoleItalicNode new.
	self 
		parseChildrenOf: bold
		until: [ self hasTerminator ].
	self skipTerminator.
	^ bold! !

!CreoleItalicParser methodsFor: 'as yet unclassified' stamp: 'cwp 1/6/2009 19:23'!
parseNode
	| char |
	char := in next.
	char = $* ifTrue: [^ self parseWith: CreoleBoldParser on: $*].
	char = $[ ifTrue: [^ self parseWith: CreoleLinkParser on: $[].
	^ self parseText! !

!CreoleItalicParser methodsFor: 'as yet unclassified' stamp: 'cwp 1/6/2009 16:52'!
skipTerminator
	in peekFor: $/.
	in peekFor: $/! !

AbstractCreoleParser subclass: #CreoleLinkContentParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Creole-Parsing'!

!CreoleLinkContentParser methodsFor: 'as yet unclassified' stamp: 'cwp 1/7/2009 12:17'!
hasTerminator
	^ self peekTwo: 
		[ :first :second | first = $] and: [second = $]]]! !

!CreoleLinkContentParser methodsFor: 'as yet unclassified' stamp: 'cwp 1/7/2009 12:30'!
parse
	| node |
	node := CreoleParentNode new.
	self 
		parseChildrenOf: node
		until: [ self hasTerminator ].
	self skipTerminator.
	node children size = 0 ifTrue: [^ nil].
	node children size = 1 ifTrue: [^ node children first].
	self skipTerminator.
	^ node
		! !

!CreoleLinkContentParser methodsFor: 'as yet unclassified' stamp: 'cwp 1/7/2009 12:14'!
parseNode
	| char |
	char := in next.
	char = $* ifTrue: [^ self parseWith: CreoleBoldParser on: $*].
	char = $/ ifTrue: [^ self parseWith: CreoleItalicParser on: $/].
	char = ${ ifTrue: [^ self parseWith: CreoleImageParser on: ${].
	char = $\ ifTrue: [^ self parseBackslash].
	^ self parseText! !

!CreoleLinkContentParser methodsFor: 'as yet unclassified' stamp: 'cwp 1/7/2009 12:19'!
skipTerminator
	in peekFor: $].
	in peekFor: $].! !

AbstractCreoleParser subclass: #CreoleListParser
	instanceVariableNames: 'level bullet'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Creole-Parsing'!

!CreoleListParser methodsFor: 'as yet unclassified' stamp: 'cwp 1/7/2009 18:21'!
createNode
	^ self isOrdered 
		ifTrue: [ CreoleOrderedListNode new ]
		ifFalse: [ CreoleUnorderedListNode new ]! !

!CreoleListParser methodsFor: 'as yet unclassified' stamp: 'cwp 1/7/2009 18:21'!
isOrdered
	^ bullet = $#! !

!CreoleListParser methodsFor: 'as yet unclassified' stamp: 'cwp 1/7/2009 18:37'!
parse
	^ [ self parseList ] 
		on: InCreoleUnorderedList
		do: [ :notification | notification resume: true ]! !

!CreoleListParser methodsFor: 'as yet unclassified' stamp: 'cwp 1/7/2009 11:00'!
parseBulletsOnFailure: aBlock 
	| itemBullet |
	itemBullet := in next.
	itemBullet ifNil: aBlock.
	itemBullet isBullet ifFalse: aBlock.
	level - 1 timesRepeat: [ in next = itemBullet ifFalse: aBlock ]! !

!CreoleListParser methodsFor: 'as yet unclassified' stamp: 'cwp 1/7/2009 01:34'!
parseFirstItem
	self skipWhitespace.
	level := 1.
	bullet := in next.
	[bullet = in next] whileTrue: [level := level + 1].
	in back.
	self skipWhitespace.
	^ CreoleListItemParser parseFrom: in! !

!CreoleListParser methodsFor: 'as yet unclassified' stamp: 'cwp 1/7/2009 11:12'!
parseItem
	| backtrack |
	backtrack := self createBacktrack.
	self skipWhitespace.
	self parseBulletsOnFailure: [backtrack value. ^ nil].
	^ in peek isBullet 
		ifTrue: 
			[backtrack value.
			CreoleListParser parseFrom: in ]
		ifFalse: 
			[ self skipWhitespace.
			CreoleListItemParser parseFrom: in ]! !

!CreoleListParser methodsFor: 'as yet unclassified' stamp: 'cwp 1/7/2009 18:21'!
parseList
	| first node child |
	first := self parseFirstItem.
	node := self createNode.
	node addChild: first.
	child := self parseItem.
	[child isNil] whileFalse:
		[node addChild: child.
		child := self parseItem].
	^ node! !

AbstractCreoleParser subclass: #CreoleNowikiParser
	instanceVariableNames: 'done out'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Creole-Parsing'!

CreoleNowikiParser subclass: #CreoleBlockNowikiParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Creole-Parsing'!

!CreoleBlockNowikiParser methodsFor: 'as yet unclassified' stamp: 'cwp 1/7/2009 16:39'!
handleClosingBrace
	| bail last |
	last := in peekBack.
	last isLineEnd ifFalse:
		[last = Character space ifTrue: [out back].
		^ self].
	
	bail := self createBacktrack: [out nextPut: $}. ^ self].
	in next = $} ifFalse: bail.
	in next = $} ifFalse: bail.
	done := true! !

!CreoleBlockNowikiParser methodsFor: 'as yet unclassified' stamp: 'cwp 1/7/2009 16:42'!
nodeClass
	^ CreoleBlockNowikiNode! !

CreoleNowikiParser subclass: #CreoleInlineNowikiParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Creole-Parsing'!

!CreoleInlineNowikiParser methodsFor: 'as yet unclassified' stamp: 'cwp 1/7/2009 16:37'!
handleClosingBrace
	| bail |
	bail := self createBacktrack: [out nextPut: $}. ^ self].
	in next = $} ifFalse: bail.
	in next = $} ifFalse: bail.
	done := true.
	[in next = $}] whileTrue: [out nextPut: $}].
	in back
! !

!CreoleInlineNowikiParser methodsFor: 'as yet unclassified' stamp: 'cwp 1/7/2009 16:42'!
nodeClass
	^ CreoleInlineNowikiNode! !

!CreoleNowikiParser methodsFor: 'as yet unclassified' stamp: 'cwp 1/7/2009 14:11'!
initialize
	out := self createOutputStream.
	done := false! !

!CreoleNowikiParser methodsFor: 'as yet unclassified' stamp: 'cwp 1/7/2009 16:42'!
parse
	| char |
	in peekFor: ${.
	[done or: [char := in next. char isNil]] whileFalse: 
		[char = $} 
			ifTrue: [self handleClosingBrace]
			ifFalse: [out nextPut: char]].
	^ self nodeClass text: out contents! !

AbstractCreoleParser subclass: #CreoleReferenceParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Creole-Parsing'!

CreoleReferenceParser subclass: #CreoleImageParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Creole-Parsing'!

!CreoleImageParser methodsFor: 'as yet unclassified' stamp: 'cwp 1/7/2009 11:50'!
closingCharacter	
	^ $}! !

!CreoleImageParser methodsFor: 'as yet unclassified' stamp: 'cwp 1/10/2009 22:38'!
defaultLabelFor: anObject
	^ nil! !

!CreoleImageParser methodsFor: 'as yet unclassified' stamp: 'cwp 1/7/2009 11:51'!
nodeClass
	^ CreoleImageNode! !

!CreoleImageParser methodsFor: 'as yet unclassified' stamp: 'cwp 1/7/2009 11:50'!
openingCharacter
	^ ${! !

!CreoleImageParser methodsFor: 'as yet unclassified' stamp: 'cwp 1/10/2009 21:08'!
parseLabel
	| out char |
	out := self createOutputStream.
	char := in next.
	char = $| ifFalse: [^ nil].
	char := in next.
	[self isTerminator: char] whileFalse: 
		[out nextPut: char.
		char := in next].
	^ out contents! !

CreoleReferenceParser subclass: #CreoleLinkParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Creole-Parsing'!

!CreoleLinkParser methodsFor: 'as yet unclassified' stamp: 'cwp 1/7/2009 11:47'!
closingCharacter
	^ $]! !

!CreoleLinkParser methodsFor: 'as yet unclassified' stamp: 'cwp 1/10/2009 22:42'!
defaultLabelFor: aString
	^ CreoleTextNode text: aString! !

!CreoleLinkParser methodsFor: 'as yet unclassified' stamp: 'cwp 1/7/2009 11:51'!
nodeClass
	^ CreoleLinkNode ! !

!CreoleLinkParser methodsFor: 'as yet unclassified' stamp: 'cwp 1/7/2009 11:46'!
openingCharacter
	^ $[! !

!CreoleLinkParser methodsFor: 'as yet unclassified' stamp: 'cwp 1/7/2009 12:38'!
parseLabel
	(in peekFor: $|) ifFalse: [^ nil].
	self skipWhitespace.
	^ CreoleLinkContentParser parseFrom: in! !

!CreoleReferenceParser methodsFor: 'as yet unclassified' stamp: 'cwp 1/7/2009 11:49'!
isTerminator: char 
	| closing |
	closing := self closingCharacter.
	^ char = closing and: [ in peek = closing ]! !

!CreoleReferenceParser methodsFor: 'as yet unclassified' stamp: 'cwp 1/10/2009 22:38'!
parse
	| reference label |
	in peekFor: self openingCharacter.
	reference := self parseReference.
	label := self parseLabel ifNil: [self defaultLabelFor: reference].
	self skipTerminator.
	^ self nodeClass
		label: label
		reference: reference! !

!CreoleReferenceParser methodsFor: 'as yet unclassified' stamp: 'cwp 1/7/2009 12:35'!
parseReference
	| out char |
	out := self createOutputStream.
	char := in next.
	[char = $| or: [self isTerminator: char]] whileFalse: 
		[out nextPut: char.
		char := in next].
	in back.
	^ out contents withBlanksTrimmed! !

!CreoleReferenceParser methodsFor: 'as yet unclassified' stamp: 'cwp 1/7/2009 11:49'!
skipTerminator
	in peekFor: self closingCharacter.
	in peekFor: self closingCharacter! !

AbstractCreoleParser subclass: #CreoleTableParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Creole-Parsing'!

!CreoleTableParser methodsFor: 'as yet unclassified' stamp: 'cwp 1/7/2009 20:44'!
hasCellTerminator
	^ in peek = $|! !

!CreoleTableParser methodsFor: 'as yet unclassified' stamp: 'cwp 1/7/2009 21:41'!
hasRowTerminator
	| rewind whitespace char result |
	rewind := self createBacktrack.
	whitespace := String new: 2.
	whitespace at: 1 put: Character space.
	whitespace at: 2 put: Character tab.
	
	[char := in next.
	whitespace includes: char] whileTrue.
	
	result := char isLineEnd.
	rewind value.
	^ result! !

!CreoleTableParser methodsFor: 'as yet unclassified' stamp: 'cwp 1/7/2009 20:36'!
hasTableTerminator
	^ in peek ~= $|! !

!CreoleTableParser methodsFor: 'as yet unclassified' stamp: 'cwp 1/7/2009 21:23'!
parse
	^ [self parseTable]
		on: InCreoleTable 
		do: [:notification | notification resume: true]! !

!CreoleTableParser methodsFor: 'as yet unclassified' stamp: 'cwp 1/7/2009 22:59'!
parseCell
	| node |
	node := CreoleCellNode new.
	(in peekFor: $=) ifTrue: [node beHeader].
	[in atEnd or: [self hasCellTerminator]] whileFalse: 
		[node addChild: self parseNode].
	self skipCellTerminator.
	^ node! !

!CreoleTableParser methodsFor: 'as yet unclassified' stamp: 'cwp 1/7/2009 22:32'!
parseNode
	| char |
	char := in next.
	char = $* ifTrue: 
		[ ^ self 
			parseWith: CreoleBoldParser
			on: $* ].
	char = $/ ifTrue: 
		[ ^ self 
			parseWith: CreoleItalicParser
			on: $/ ].
	char = $[ ifTrue: 
		[ ^ self 
			parseWith: CreoleLinkParser
			on: $[ ].
	char = ${ ifTrue: [ ^ self parseOpeningBrace ].
	char = $\ ifTrue: [ ^ self parseBackslash ].
	^ self parseText! !

!CreoleTableParser methodsFor: 'as yet unclassified' stamp: 'cwp 1/7/2009 22:42'!
parseOpeningBrace
	^ in peek = ${
		ifTrue: 
			[in skip: 1.
			in peek = ${
				ifTrue: [CreoleInlineNowikiParser parseFrom: in]
				ifFalse: 
					[in back; back.
					CreoleTextParser parseFrom: in]]
		ifFalse: 
			[in back.
			CreoleTextParser parseFrom: in]
		
		! !

!CreoleTableParser methodsFor: 'as yet unclassified' stamp: 'cwp 1/7/2009 20:46'!
parseRow
	| node |
	self checkFor: $|.
	node := CreoleRowNode new.
	[in atEnd or: [self hasRowTerminator]] whileFalse: 
		[node addChild: self parseCell].
	self skipRowTerminator.
	^ node! !

!CreoleTableParser methodsFor: 'as yet unclassified' stamp: 'cwp 1/7/2009 20:46'!
parseTable
	| node |
	node := CreoleTableNode new.
	[in atEnd or: [self hasTableTerminator]] 
		whileFalse: [node addChild: self parseRow].
	^ node! !

!CreoleTableParser methodsFor: 'as yet unclassified' stamp: 'cwp 1/7/2009 20:44'!
skipCellTerminator
	in peekFor: $|! !

!CreoleTableParser methodsFor: 'as yet unclassified' stamp: 'cwp 1/7/2009 21:48'!
skipRowTerminator
	self skipWhitespace! !

AbstractCreoleParser subclass: #CreoleTextParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Creole-Parsing'!

!CreoleTextParser methodsFor: 'as yet unclassified' stamp: 'cwp 1/7/2009 21:21'!
isCellTerminator: first
	^ first = $| and: [InCreoleTable signal]! !

!CreoleTextParser methodsFor: 'as yet unclassified' stamp: 'cwp 1/7/2009 18:11'!
isMarkup: first
	^ ('*/\[]{}' includes: first) and: [in peek = first]! !

!CreoleTextParser methodsFor: 'as yet unclassified' stamp: 'cwp 1/7/2009 21:21'!
isTerminator: first
	^ (self isBlockTerminator: first) 
		or: [self isMarkup: first]
		or: [self isCellTerminator: first]! !

!CreoleTextParser methodsFor: 'as yet unclassified' stamp: 'cwp 1/7/2009 01:43'!
parse
	| out char |
	out := self createOutputStream.
	char := in next.
	[ char isNil or: [ self isTerminator: char ] ] whileFalse: 
		[ self 
			putChar: char
			in: out.
		char := in next ].
	char ifNotNil: [ in back ].
	^ CreoleTextNode text: out contents! !

!CreoleTextParser methodsFor: 'as yet unclassified' stamp: 'cwp 1/8/2009 11:56'!
putChar: char in: out 
	char isSeparator
		ifTrue: [out nextPut: Character space]
		ifFalse: 
			[char = $~
				ifTrue: [out nextPut: in next]
				ifFalse: [out nextPut: char]]! !

Object subclass: #CreoleNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Creole-Nodes'!

CreoleNode subclass: #CreoleBreakNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Creole-Nodes'!

!CreoleBreakNode methodsFor: 'as yet unclassified' stamp: 'cwp 1/10/2009 13:47'!
accept: aVisitor
	^ aVisitor visitBreak: self! !

!CreoleBreakNode methodsFor: 'as yet unclassified' stamp: 'cwp 1/6/2009 17:51'!
isBreakNode
	^ true! !

CreoleNode subclass: #CreoleHeadingNode
	instanceVariableNames: 'level text'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Creole-Nodes'!

!CreoleHeadingNode class methodsFor: 'as yet unclassified' stamp: 'cwp 1/6/2009 18:07'!
level: anInteger text: aString
	^ self new setLevel: anInteger text: aString! !

!CreoleHeadingNode methodsFor: 'visiting' stamp: 'cwp 1/10/2009 14:19'!
accept: aVisitor
	^ aVisitor visitHeading: self! !

!CreoleHeadingNode methodsFor: 'testing' stamp: 'cwp 1/6/2009 18:08'!
isHeadingNode
	^ true! !

!CreoleHeadingNode methodsFor: 'accessing' stamp: 'cwp 1/6/2009 18:08'!
level
	^ level! !

!CreoleHeadingNode methodsFor: 'accessing' stamp: 'cwp 1/6/2009 18:16'!
setLevel: anInteger text: aString
	level := anInteger.
	text := aString withBlanksTrimmed.! !

!CreoleHeadingNode methodsFor: 'accessing' stamp: 'cwp 1/6/2009 18:08'!
text
	^ text! !

CreoleNode subclass: #CreoleLinkNode
	instanceVariableNames: 'label reference'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Creole-Nodes'!

CreoleLinkNode subclass: #CreoleImageNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Creole-Nodes'!

!CreoleImageNode methodsFor: 'printing' stamp: 'cwp 1/10/2009 14:29'!
accept: aVisitor
	^ aVisitor visitImage: self! !

!CreoleImageNode methodsFor: 'testing' stamp: 'cwp 1/7/2009 11:42'!
isImageNode
	^ true! !

!CreoleLinkNode class methodsFor: 'as yet unclassified' stamp: 'cwp 1/6/2009 18:53'!
label: aString reference: aNode
	^ self new setLabel: aString reference: aNode! !

!CreoleLinkNode methodsFor: 'visiting' stamp: 'cwp 1/10/2009 14:29'!
accept: aVisitor
	^ aVisitor 
		visitLink: self 
		with: [aVisitor visit: label]! !

!CreoleLinkNode methodsFor: 'testing' stamp: 'cwp 1/6/2009 19:03'!
isLinkNode
	^ true! !

!CreoleLinkNode methodsFor: 'accessing' stamp: 'cwp 1/6/2009 18:34'!
label
	^ label! !

!CreoleLinkNode methodsFor: 'accessing' stamp: 'cwp 1/6/2009 18:34'!
reference
	^ reference! !

!CreoleLinkNode methodsFor: 'accessing' stamp: 'cwp 1/10/2009 22:19'!
reference: aString
	reference := aString! !

!CreoleLinkNode methodsFor: 'initialize-release' stamp: 'cwp 1/6/2009 18:53'!
setLabel: aString reference: aNode
	label := aString.
	reference := aNode.! !

!CreoleNode methodsFor: 'visiting' stamp: 'cwp 1/10/2009 13:50'!
accept: aVisitor
	^ aVisitor visitNode: self! !

!CreoleNode methodsFor: 'testing' stamp: 'cwp 1/7/2009 16:39'!
isBlockNowikiNode
	^ false! !

!CreoleNode methodsFor: 'testing' stamp: 'cwp 1/6/2009 05:12'!
isBoldNode
	^ false! !

!CreoleNode methodsFor: 'testing' stamp: 'cwp 1/6/2009 17:51'!
isBreakNode
	^ false! !

!CreoleNode methodsFor: 'testing' stamp: 'cwp 1/7/2009 20:13'!
isCellNode
	^ false! !

!CreoleNode methodsFor: 'testing' stamp: 'cwp 1/6/2009 18:07'!
isHeadingNode
	^ false! !

!CreoleNode methodsFor: 'testing' stamp: 'cwp 1/7/2009 11:41'!
isImageNode
	^ false! !

!CreoleNode methodsFor: 'testing' stamp: 'cwp 1/7/2009 13:18'!
isInlineNowikiNode
	^ false! !

!CreoleNode methodsFor: 'testing' stamp: 'cwp 1/6/2009 12:13'!
isItalicNode
	^ false! !

!CreoleNode methodsFor: 'testing' stamp: 'cwp 1/7/2009 01:26'!
isItemNode
	^ false! !

!CreoleNode methodsFor: 'testing' stamp: 'cwp 1/6/2009 18:35'!
isLinkNode
	^ false! !

!CreoleNode methodsFor: 'testing' stamp: 'cwp 1/7/2009 10:11'!
isListNode
	^ false! !

!CreoleNode methodsFor: 'testing' stamp: 'cwp 1/7/2009 10:34'!
isOrderedListNode
	^ false! !

!CreoleNode methodsFor: 'testing' stamp: 'cwp 1/6/2009 05:10'!
isParagraphNode
	^ false! !

!CreoleNode methodsFor: 'testing' stamp: 'cwp 1/7/2009 20:13'!
isRowNode
	^ false! !

!CreoleNode methodsFor: 'testing' stamp: 'cwp 1/7/2009 11:21'!
isRuleNode
	^ false! !

!CreoleNode methodsFor: 'testing' stamp: 'cwp 1/7/2009 20:13'!
isTableNode
	^ false! !

!CreoleNode methodsFor: 'testing' stamp: 'cwp 1/6/2009 04:22'!
isTextNode
	^ false! !

!CreoleNode methodsFor: 'testing' stamp: 'cwp 1/7/2009 01:24'!
isUnorderedListNode
	^ false! !

CreoleNode subclass: #CreoleNowikiNode
	instanceVariableNames: 'text'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Creole-Nodes'!

CreoleNowikiNode subclass: #CreoleBlockNowikiNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Creole-Nodes'!

!CreoleBlockNowikiNode methodsFor: 'as yet unclassified' stamp: 'cwp 1/10/2009 21:18'!
accept: aVisitor
	^ aVisitor visitNowikiBlock: self! !

!CreoleBlockNowikiNode methodsFor: 'testing' stamp: 'cwp 1/7/2009 16:41'!
isBlockNowikiNode
	^ true! !

CreoleNowikiNode subclass: #CreoleInlineNowikiNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Creole-Nodes'!

!CreoleInlineNowikiNode methodsFor: 'as yet unclassified' stamp: 'cwp 1/10/2009 21:21'!
accept: aVisitor
	^ aVisitor visitNowikiSpan: self! !

!CreoleInlineNowikiNode methodsFor: 'as yet unclassified' stamp: 'cwp 1/7/2009 13:18'!
isInlineNowikiNode
	^ true! !

!CreoleNowikiNode class methodsFor: 'as yet unclassified' stamp: 'cwp 1/7/2009 16:43'!
text: aString
	^ self new setText: aString! !

!CreoleNowikiNode methodsFor: 'as yet unclassified' stamp: 'cwp 1/7/2009 16:40'!
setText: aString
	text := aString! !

!CreoleNowikiNode methodsFor: 'as yet unclassified' stamp: 'cwp 1/7/2009 16:41'!
text
	^ text! !

CreoleNode subclass: #CreoleParentNode
	instanceVariableNames: 'children'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Creole-Nodes'!

CreoleParentNode subclass: #CreoleBoldNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Creole-Nodes'!

!CreoleBoldNode methodsFor: 'testing' stamp: 'cwp 1/6/2009 05:15'!
isBoldNode
	^ true! !

!CreoleBoldNode methodsFor: 'as yet unclassified' stamp: 'cwp 1/10/2009 21:28'!
visitingSelector
	^ #visitBold:with:! !

CreoleParentNode subclass: #CreoleCellNode
	instanceVariableNames: 'header'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Creole-Nodes'!

!CreoleCellNode methodsFor: 'accessing' stamp: 'cwp 1/7/2009 22:58'!
beHeader
	header := true! !

!CreoleCellNode methodsFor: 'initialize-release' stamp: 'cwp 1/7/2009 22:59'!
initialize
	super initialize.
	header := false! !

!CreoleCellNode methodsFor: 'testing' stamp: 'cwp 1/7/2009 21:22'!
isCellNode
	^ true! !

!CreoleCellNode methodsFor: 'accessing' stamp: 'cwp 1/7/2009 22:55'!
isHeader
	^ header! !

!CreoleCellNode methodsFor: 'as yet unclassified' stamp: 'cwp 1/10/2009 21:43'!
visitingSelector
	^ #visitCell:with:! !

CreoleParentNode subclass: #CreoleItalicNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Creole-Nodes'!

!CreoleItalicNode methodsFor: 'as yet unclassified' stamp: 'cwp 1/6/2009 12:15'!
isItalicNode
	^ true! !

!CreoleItalicNode methodsFor: 'as yet unclassified' stamp: 'cwp 1/10/2009 21:34'!
visitingSelector
	^ #visitItalic:with:! !

CreoleParentNode subclass: #CreoleItemNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Creole-Nodes'!

!CreoleItemNode methodsFor: 'testing' stamp: 'cwp 1/7/2009 01:27'!
isItemNode
	^ true! !

!CreoleItemNode methodsFor: 'as yet unclassified' stamp: 'cwp 1/10/2009 21:39'!
visitingSelector
	^ #visitListItem:with:! !

CreoleParentNode subclass: #CreoleListNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Creole-Nodes'!

!CreoleListNode methodsFor: 'accessing' stamp: 'cwp 1/7/2009 10:11'!
addChild: aNode
	aNode isListNode
		ifTrue: [children last addChild: aNode]
		ifFalse: [super addChild: aNode]! !

!CreoleListNode methodsFor: 'testing' stamp: 'cwp 1/7/2009 10:11'!
isListNode
	^ true! !

CreoleListNode subclass: #CreoleOrderedListNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Creole-Nodes'!

!CreoleOrderedListNode methodsFor: 'testing' stamp: 'cwp 1/7/2009 10:34'!
isOrderedListNode
	^ true! !

!CreoleOrderedListNode methodsFor: 'as yet unclassified' stamp: 'cwp 1/10/2009 21:41'!
visitingSelector
	^ #visitOrderedList:with:! !

CreoleListNode subclass: #CreoleUnorderedListNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Creole-Nodes'!

!CreoleUnorderedListNode methodsFor: 'as yet unclassified' stamp: 'cwp 1/7/2009 01:25'!
isUnorderedListNode 
	^ true! !

!CreoleUnorderedListNode methodsFor: 'as yet unclassified' stamp: 'cwp 1/10/2009 21:36'!
visitingSelector
	^ #visitUnorderedList:with:! !

CreoleParentNode subclass: #CreoleParagraphNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Creole-Nodes'!

!CreoleParagraphNode methodsFor: 'testing' stamp: 'cwp 1/6/2009 05:10'!
isParagraphNode
	^ true! !

!CreoleParagraphNode methodsFor: 'visiting' stamp: 'cwp 1/10/2009 21:35'!
visitingSelector
	^ #visitParagraph:with:! !

!CreoleParentNode class methodsFor: 'as yet unclassified' stamp: 'cwp 1/9/2009 14:35'!
text: aString
	^ self with: (CreoleTextNode text: aString)! !

!CreoleParentNode class methodsFor: 'as yet unclassified' stamp: 'cwp 1/6/2009 04:58'!
with: aNode
	^ self new
		addChild: aNode;
		yourself! !

!CreoleParentNode class methodsFor: 'as yet unclassified' stamp: 'cwp 1/6/2009 11:56'!
withAll: nodes
	| instance |
	instance := self new.
	nodes do: [:node | instance addChild: node].
	^ instance! !

!CreoleParentNode methodsFor: 'visiting' stamp: 'cwp 1/10/2009 21:29'!
accept: aVisitor 
	^ aVisitor 
		perform: self visitingSelector
		with: self
		with: [children do: [:ea | ea accept: aVisitor]]! !

!CreoleParentNode methodsFor: 'accessing' stamp: 'cwp 1/6/2009 12:43'!
addChild: aNode
	(children isEmpty not and:
		[children last isTextNode 
			and: [aNode isTextNode]])
				ifTrue: [children last append: aNode]
				ifFalse: [children add: aNode]! !

!CreoleParentNode methodsFor: 'accessing' stamp: 'cwp 1/6/2009 04:37'!
children
	^ children! !

!CreoleParentNode methodsFor: 'initialize-release' stamp: 'cwp 1/6/2009 04:37'!
initialize
	super initialize.
	children := OrderedCollection new! !

!CreoleParentNode methodsFor: 'visiting' stamp: 'cwp 1/10/2009 21:27'!
visitingSelector
	^ #visitParent:with:! !

CreoleParentNode subclass: #CreoleRowNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Creole-Nodes'!

!CreoleRowNode methodsFor: 'testing' stamp: 'cwp 1/7/2009 21:22'!
isRowNode
	^ true! !

!CreoleRowNode methodsFor: 'as yet unclassified' stamp: 'cwp 1/10/2009 21:43'!
visitingSelector
	^ #visitRow:with:! !

CreoleParentNode subclass: #CreoleTableNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Creole-Nodes'!

!CreoleTableNode methodsFor: 'testing' stamp: 'cwp 1/7/2009 21:22'!
isTableNode
	^ true! !

!CreoleTableNode methodsFor: 'as yet unclassified' stamp: 'cwp 1/10/2009 21:43'!
visitingSelector
	^ #visitTable:with:! !

CreoleNode subclass: #CreoleRuleNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Creole-Nodes'!

!CreoleRuleNode methodsFor: 'as yet unclassified' stamp: 'cwp 1/10/2009 21:54'!
accept: aVisitor
	^ aVisitor visitRule: self! !

!CreoleRuleNode methodsFor: 'as yet unclassified' stamp: 'cwp 1/7/2009 11:26'!
isRuleNode
	^ true! !

CreoleNode subclass: #CreoleTextNode
	instanceVariableNames: 'text'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Creole-Nodes'!

!CreoleTextNode class methodsFor: 'as yet unclassified' stamp: 'cwp 1/6/2009 04:21'!
text: aString
	^ self new setText: aString! !

!CreoleTextNode methodsFor: 'as yet unclassified' stamp: 'cwp 1/10/2009 21:13'!
accept: aVisitor
	^ aVisitor visitText: self! !

!CreoleTextNode methodsFor: 'as yet unclassified' stamp: 'cwp 1/6/2009 12:42'!
append: other
	text := text, other text! !

!CreoleTextNode methodsFor: 'as yet unclassified' stamp: 'cwp 1/6/2009 04:22'!
isTextNode
	^ true! !

!CreoleTextNode methodsFor: 'as yet unclassified' stamp: 'cwp 1/6/2009 04:21'!
setText: aString
	text := aString! !

!CreoleTextNode methodsFor: 'as yet unclassified' stamp: 'cwp 1/6/2009 04:22'!
text
	^ text! !

Object subclass: #CreoleVisitor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Creole-Visitors'!

CreoleVisitor subclass: #CreoleHtmlPrinter
	instanceVariableNames: 'out'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Creole-Visitors'!

!CreoleHtmlPrinter class methodsFor: 'as yet unclassified' stamp: 'cwp 1/10/2009 13:46'!
on: aStream
	^ self new setStream: aStream! !

!CreoleHtmlPrinter class methodsFor: 'as yet unclassified' stamp: 'cwp 1/10/2009 13:53'!
print: aNode 
	| out |
	out := (String new: 10) writeStream.
	self print: aNode on: out.
	^ out contents! !

!CreoleHtmlPrinter class methodsFor: 'as yet unclassified' stamp: 'cwp 1/10/2009 13:53'!
print: aNode on: aWriteStream 
	(self on: aWriteStream) visit: aNode! !

!CreoleHtmlPrinter methodsFor: 'initialize-release' stamp: 'cwp 1/10/2009 13:46'!
setStream: aStream
	out := aStream! !

!CreoleHtmlPrinter methodsFor: 'private' stamp: 'cwp 1/10/2009 21:34'!
tag: aString with: aBlock
	out 
		nextPut: $<;
		nextPutAll: aString;
		nextPut: $>.
	aBlock value.
	out 
		nextPutAll: '</';
		nextPutAll: aString;
		nextPut: $>! !

!CreoleHtmlPrinter methodsFor: 'visiting' stamp: 'cwp 1/10/2009 21:31'!
visitBold: aNode with: aBlock
	self tag: 'strong' with: aBlock! !

!CreoleHtmlPrinter methodsFor: 'visiting' stamp: 'cwp 1/10/2009 13:48'!
visitBreak: aNode
	out nextPutAll: '<br />'! !

!CreoleHtmlPrinter methodsFor: 'visiting' stamp: 'cwp 1/10/2009 21:55'!
visitCell: aNode with: aBlock
	^ self 
		tag: (aNode isHeader ifTrue: ['th'] ifFalse: ['td'])
		with: aBlock! !

!CreoleHtmlPrinter methodsFor: 'visiting' stamp: 'cwp 1/10/2009 14:20'!
visitHeading: aNode
	out
		nextPutAll: '<h';
		print: aNode level;
		nextPut: $>;
		nextPutAll: aNode text;
		nextPutAll: '</h';
		print: aNode level;
		nextPut: $>! !

!CreoleHtmlPrinter methodsFor: 'visiting' stamp: 'cwp 1/10/2009 14:33'!
visitImage: aNode
	out
		nextPutAll: '<img src="';
		nextPutAll: aNode reference;
		nextPut: $".
	aNode label ifNotNil:
		[out 
			nextPutAll: ' alt="';
			nextPutAll: aNode label;
			nextPut: $"].
	out nextPutAll: ' />'
		
		! !

!CreoleHtmlPrinter methodsFor: 'visiting' stamp: 'cwp 1/10/2009 21:35'!
visitItalic: aNode with: aBlock
	self tag: 'em' with: aBlock! !

!CreoleHtmlPrinter methodsFor: 'visiting' stamp: 'cwp 1/10/2009 14:27'!
visitLink: aNode with: aBlock
	out
		nextPutAll: '<a href="';
		nextPutAll: aNode reference;
		nextPutAll: '">'.
	aBlock value.
	out nextPutAll: '</a>'! !

!CreoleHtmlPrinter methodsFor: 'visiting' stamp: 'cwp 1/10/2009 21:55'!
visitListItem: aNode with: aBlock
	^ self tag: 'li' with: aBlock! !

!CreoleHtmlPrinter methodsFor: 'visiting' stamp: 'cwp 1/10/2009 21:18'!
visitNowikiBlock: aNode
	out 
		cr;
		nextPutAll: '<pre>';
		cr;
		nextPutAll: aNode text;
		nextPutAll: '</pre>'! !

!CreoleHtmlPrinter methodsFor: 'visiting' stamp: 'cwp 1/10/2009 21:22'!
visitNowikiSpan: aNode
	out
		nextPutAll: '<tt>';
		nextPutAll: aNode text;
		nextPutAll: '</tt>'! !

!CreoleHtmlPrinter methodsFor: 'visiting' stamp: 'cwp 1/10/2009 21:42'!
visitOrderedList: aNode with: aBlock
	^ self tag: 'ol' with: aBlock! !

!CreoleHtmlPrinter methodsFor: 'visiting' stamp: 'cwp 1/10/2009 21:36'!
visitParagraph: aNode with: aBlock
	self tag: 'p' with: aBlock! !

!CreoleHtmlPrinter methodsFor: 'visiting' stamp: 'cwp 1/10/2009 21:55'!
visitRow: aNode with: aBlock
	^ self tag: 'tr' with: aBlock! !

!CreoleHtmlPrinter methodsFor: 'visiting' stamp: 'cwp 1/10/2009 21:57'!
visitRule: aNode
	out nextPutAll: '<hr />'! !

!CreoleHtmlPrinter methodsFor: 'visiting' stamp: 'cwp 1/10/2009 21:55'!
visitTable: aNode with: aBlock
	^ self tag: 'table' with: aBlock! !

!CreoleHtmlPrinter methodsFor: 'visiting' stamp: 'cwp 1/10/2009 21:14'!
visitText: aNode
	out nextPutAll: aNode text! !

!CreoleHtmlPrinter methodsFor: 'visiting' stamp: 'cwp 1/10/2009 21:37'!
visitUnorderedList: aNode with: aBlock
	^ self tag: 'ul' with: aBlock! !

CreoleVisitor subclass: #CreoleLinker
	instanceVariableNames: 'prefix'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Creole-Visitors'!

!CreoleLinker class methodsFor: 'as yet unclassified' stamp: 'cwp 1/10/2009 22:22'!
link: aNode at: aString
	(self prefix: aString) visit: aNode! !

!CreoleLinker class methodsFor: 'as yet unclassified' stamp: 'cwp 1/10/2009 22:23'!
prefix: aString
	^ self new setPrefix: aString! !

!CreoleLinker methodsFor: 'initialize-release' stamp: 'cwp 1/10/2009 22:24'!
setPrefix: aString
	prefix := aString! !

!CreoleLinker methodsFor: 'visiting' stamp: 'cwp 1/19/2009 22:54'!
visitImage: aNode
	(aNode reference beginsWith: 'http:')
		ifFalse: [aNode reference: prefix, aNode reference]! !

!CreoleLinker methodsFor: 'visiting' stamp: 'cwp 1/19/2009 22:54'!
visitLink: aNode with: aBlock
	(aNode reference beginsWith: 'http:')
		ifFalse: [aNode reference: prefix, aNode reference, '.html']! !

!CreoleVisitor methodsFor: 'visiting' stamp: 'cwp 1/10/2009 13:45'!
visit: aNode
	^ aNode accept: self! !

!CreoleVisitor methodsFor: 'visiting' stamp: 'cwp 1/10/2009 22:29'!
visitBold: aNode with: aBlock
	^ self visitParent: aNode with: aBlock! !

!CreoleVisitor methodsFor: 'visiting' stamp: 'cwp 1/10/2009 13:47'!
visitBreak: aNode! !

!CreoleVisitor methodsFor: 'visiting' stamp: 'cwp 1/10/2009 22:29'!
visitCell: aNode with: aBlock
	^ self visitParent: aNode with: aBlock! !

!CreoleVisitor methodsFor: 'visiting' stamp: 'cwp 1/10/2009 14:20'!
visitHeading: aNode
	! !

!CreoleVisitor methodsFor: 'visiting' stamp: 'cwp 1/10/2009 21:32'!
visitImage: aNode! !

!CreoleVisitor methodsFor: 'visiting' stamp: 'cwp 1/10/2009 22:29'!
visitItalic: aNode with: aBlock
	^ self visitParent: aNode with: aBlock! !

!CreoleVisitor methodsFor: 'visiting' stamp: 'cwp 1/10/2009 22:29'!
visitLink: aNode with: aBlock
	^ self visitParent: aNode with: aBlock! !

!CreoleVisitor methodsFor: 'visiting' stamp: 'cwp 1/10/2009 22:29'!
visitListItem: aNode with: aBlock
	^ self visitParent: aNode with: aBlock! !

!CreoleVisitor methodsFor: 'visiting' stamp: 'cwp 1/10/2009 13:54'!
visitNode: aNode! !

!CreoleVisitor methodsFor: 'visiting' stamp: 'cwp 1/10/2009 21:18'!
visitNowikiBlock: aNode
	! !

!CreoleVisitor methodsFor: 'visiting' stamp: 'cwp 1/10/2009 21:22'!
visitNowikiSpan: aNode
	! !

!CreoleVisitor methodsFor: 'visiting' stamp: 'cwp 1/10/2009 22:30'!
visitOrderedList: aNode with: aBlock
	^ self visitParent: aNode with: aBlock! !

!CreoleVisitor methodsFor: 'visiting' stamp: 'cwp 1/10/2009 22:30'!
visitParagraph: aNode with: aBlock
	^ self visitParent: aNode with: aBlock! !

!CreoleVisitor methodsFor: 'visiting' stamp: 'cwp 1/10/2009 22:29'!
visitParent: aNode with: aBlock
	^ aBlock value
	! !

!CreoleVisitor methodsFor: 'visiting' stamp: 'cwp 1/10/2009 22:30'!
visitRow: aNode with: aBlock
	^ self visitParent: aNode with: aBlock! !

!CreoleVisitor methodsFor: 'visiting' stamp: 'cwp 1/10/2009 21:56'!
visitRule: aNode! !

!CreoleVisitor methodsFor: 'visiting' stamp: 'cwp 1/10/2009 22:30'!
visitTable: aNode with: aBlock
	^ self visitParent: aNode with: aBlock! !

!CreoleVisitor methodsFor: 'visiting' stamp: 'cwp 1/10/2009 21:13'!
visitText: aNode! !

!CreoleVisitor methodsFor: 'visiting' stamp: 'cwp 1/10/2009 22:30'!
visitUnorderedList: aNode with: aBlock
	^ self visitParent: aNode with: aBlock! !

!Character methodsFor: '*creole-testing' stamp: 'cwp 1/7/2009 10:55'!
isBullet
	"Answer whether the receiver is used by Creole to indicate
	a list item - $# or $*"

	value = 35 ifTrue: [^true].	"$#"
	value = 42 ifTrue: [^true].	"$*"
	^false
	
! !

!Character methodsFor: '*creole-testing' stamp: 'cwp 1/6/2009 11:25'!
isLineEnd
	"Answer whether the receiver is a line-ending character --
	carriage return or line feed."

	value = 13 ifTrue: [^true].	"cr"
	value = 10 ifTrue: [^true].	"line feed"
	^false! !

TestCase subclass: #CreoleHtmlTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Creole-Tests'!

!CreoleHtmlTest methodsFor: 'asserting' stamp: 'cwp 1/10/2009 22:11'!
assert: aNode hasHtml: aString
	| html |
	html := CreoleHtmlPrinter print: aNode.
	self assert: html = aString! !

!CreoleHtmlTest methodsFor: 'tests' stamp: 'cwp 1/10/2009 13:49'!
test01Break
	self assert: CreoleBreakNode new hasHtml: '<br />'! !

!CreoleHtmlTest methodsFor: 'tests' stamp: 'cwp 1/10/2009 14:34'!
test02Heading1
	| node |
	node := CreoleHeadingNode level: 1 text: 'heading'.
	self assert: node hasHtml: '<h1>heading</h1>'! !

!CreoleHtmlTest methodsFor: 'tests' stamp: 'cwp 1/10/2009 14:35'!
test03Heading2
	| node |
	node := CreoleHeadingNode 
		level: 2
		text: 'heading2'.
	self assert: node hasHtml: '<h2>heading2</h2>'! !

!CreoleHtmlTest methodsFor: 'tests' stamp: 'cwp 1/10/2009 14:35'!
test04Link
	| node |
	node := CreoleLinkNode label: (CreoleTextNode text: 'abc') reference: 'def'.
	self assert: node hasHtml: '<a href="def">abc</a>'! !

!CreoleHtmlTest methodsFor: 'tests' stamp: 'cwp 1/10/2009 21:19'!
test05Image
	| node |
	node := CreoleImageNode label: 'abc' reference: 'def'.
	self assert: node hasHtml: '<img src="def" alt="abc" />'! !

!CreoleHtmlTest methodsFor: 'tests' stamp: 'cwp 1/10/2009 21:19'!
test06ImageNoLabel
	| node |
	node := CreoleImageNode label: nil reference: 'def'.
	self assert: node hasHtml: '<img src="def" />'! !

!CreoleHtmlTest methodsFor: 'tests' stamp: 'cwp 1/10/2009 21:19'!
test07NowikiBlock
	| node |
	node := CreoleBlockNowikiNode text: 'abc\' withCRs.
	self assert: node hasHtml: '\<pre>\abc\</pre>' withCRs! !

!CreoleHtmlTest methodsFor: 'tests' stamp: 'cwp 1/10/2009 21:20'!
test08NowikiSpan
	| node |
	node := CreoleInlineNowikiNode text: 'abc' withCRs.
	self assert: node hasHtml:  '<tt>abc</tt>'! !

!CreoleHtmlTest methodsFor: 'tests' stamp: 'cwp 1/10/2009 21:23'!
test09Bold
	| node |
	node := CreoleBoldNode text: 'abc'.
	self assert: node hasHtml: '<strong>abc</strong>'! !

!CreoleHtmlTest methodsFor: 'tests' stamp: 'cwp 1/10/2009 22:01'!
test10Italics
	| node |
	node := CreoleItalicNode text: 'abc'.
	self assert: node hasHtml: '<em>abc</em>'! !

!CreoleHtmlTest methodsFor: 'tests' stamp: 'cwp 1/10/2009 22:01'!
test11Paragraph
	| node |
	node := CreoleParagraphNode text: 'abc'.
	self assert: node hasHtml: '<p>abc</p>'! !

!CreoleHtmlTest methodsFor: 'tests' stamp: 'cwp 1/10/2009 22:01'!
test12UnorderedList
	| node |
	node := CreoleDocumentParser parse: '* one\* two' withCRs.
	self assert: node hasHtml: '<ul><li>one</li><li>two</li></ul>'! !

!CreoleHtmlTest methodsFor: 'tests' stamp: 'cwp 1/10/2009 22:01'!
test13OrderedList
	| node |
	node := CreoleDocumentParser parse: '# one\# two' withCRs.
	self assert: node hasHtml: '<ol><li>one</li><li>two</li></ol>'! !

!CreoleHtmlTest methodsFor: 'tests' stamp: 'cwp 1/10/2009 22:02'!
test14Table
	| node |
	node := CreoleDocumentParser parse: '|one|two|\|three|four|' withCRs.
	self 
		assert: node 
		hasHtml: '<table><tr><td>one</td><td>two</td></tr><tr><td>three</td><td>four</td></tr></table>'! !

!CreoleHtmlTest methodsFor: 'tests' stamp: 'cwp 1/10/2009 22:02'!
test15TableWithHeaders
	| node |
	node := CreoleDocumentParser parse: '|=one|=two|\|three|four|' withCRs.
	self 
		assert: node 
		hasHtml: '<table><tr><th>one</th><th>two</th></tr><tr><td>three</td><td>four</td></tr></table>'! !

!CreoleHtmlTest methodsFor: 'tests' stamp: 'cwp 1/10/2009 22:08'!
test16Rule
	| node |
	node := CreoleRuleNode new.
	self assert: node hasHtml: '<hr />'! !

TestCase subclass: #CreoleParserTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Creole-Tests'!

!CreoleParserTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/6/2009 05:17'!
first: aString
	| root |
	root := self parse: aString.
	^ root children first.
	! !

!CreoleParserTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/9/2009 12:41'!
parse: aString
	^ CreoleDocumentParser parse: aString! !

!CreoleParserTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/6/2009 05:14'!
test01PlainText
	| node |
	node := self first: 'This is text'.
	self assert: node isTextNode.
	self assert: node text = 'This is text'! !

!CreoleParserTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/6/2009 04:42'!
test02Paragraphs
	| node |
	node := self parse: 'This is text\\This is more text' withCRs.
	self assert: node children size = 2.
	node := node children first.
	self assert: node isParagraphNode.
	self assert: node children size = 1.
	node := node children first.
	self assert: node isTextNode.
	self assert: node text = 'This is text'! !

!CreoleParserTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/6/2009 11:03'!
test03Bold
	| node |
	node := self first: '**This is bold**'.
	self assert: node isBoldNode.
	self assert: node children size = 1.
	node := node children first.
	self assert: node isTextNode.
	self assert: node text = 'This is bold'.! !

!CreoleParserTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/6/2009 11:12'!
test04BoldWithStar
	| node |
	node := self first: '**3 * 4**'.
	self assert: node isBoldNode.
	self assert: node children size = 1.
	node := node children first.
	self assert: node isTextNode.
	self assert: node text = '3 * 4'.! !

!CreoleParserTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/6/2009 12:30'!
test05BoldAcrossParagraphs
	| node root |
	root := self parse: 'first **paragraph\\second** paragraph' withCRs.
	node := root children first.
	self assert: node isParagraphNode.
	self assert: node children size = 2.
	
	node := node children second.
	self assert: node isBoldNode.
	self assert: node children first text = 'paragraph'.
	
	node := root children second.
	self assert: node isParagraphNode.
	self assert: node children size = 2.
	
	node := node children second.
	self assert: node isBoldNode.
	self assert: node children first text = ' paragraph'! !

!CreoleParserTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/6/2009 12:12'!
test06Italics
	| node |
	node := self first: '//This is italic//'.
	self assert: node isItalicNode.
	self assert: node children size = 1.
	node := node children first.
	self assert: node isTextNode.
	self assert: node text = 'This is italic'.! !

!CreoleParserTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/6/2009 12:29'!
test07ItalicsWithSlash
	| node |
	node := self first: '//3 / 4//'.
	self assert: node isItalicNode.
	self assert: node children size = 1.
	node := node children first.
	self assert: node isTextNode.
	self assert: node text = '3 / 4'.! !

!CreoleParserTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/6/2009 12:30'!
test08ItalicsAcrossParagraphs
	| node root |
	root := self parse: 'first //paragraph\\second// paragraph' withCRs.
	node := root children first.
	self assert: node isParagraphNode.
	self assert: node children size = 2.
	
	node := node children second.
	self assert: node isItalicNode.
	self assert: node children first text = 'paragraph'.
	
	node := root children second.
	self assert: node isParagraphNode.
	self assert: node children size = 2.
	
	node := node children second.
	self assert: node isItalicNode.
	self assert: node children first text = ' paragraph'! !

!CreoleParserTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/6/2009 12:31'!
test09TextWithStar
	| node |
	node := self parse: '3 * 4'.
	self assert: node isParagraphNode.
	self assert: node children size = 1.
	node := node children first.
	self assert: node isTextNode.
	self assert: node text = '3 * 4'.! !

!CreoleParserTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/6/2009 12:31'!
test10TextWithSlash
	| node |
	node := self parse: '3 / 4'.
	self assert: node isParagraphNode.
	self assert: node children size = 1.
	node := node children first.
	self assert: node isTextNode.
	self assert: node text = '3 / 4'.! !

!CreoleParserTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/6/2009 16:47'!
test11BoldAndItalic
	| node |
	node := self first: '**//emphasized//**'.
	self assert: node isBoldNode.
	self assert: node children size = 1.
	node := node children first.
	self assert: node isItalicNode.
	self assert: node children size = 1.
	node := node children first.
	self assert: node isTextNode.
	self assert: node text = 'emphasized'! !

!CreoleParserTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/6/2009 16:55'!
test12ItalicAndBold
	| node |
	node := self first: '//**emphasized**//'.
	self assert: node isItalicNode.
	self assert: node children size = 1.
	node := node children first.
	self assert: node isBoldNode.
	self assert: node children size = 1.
	node := node children first.
	self assert: node isTextNode.
	self assert: node text = 'emphasized'! !

!CreoleParserTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/6/2009 17:04'!
test13ItalicWithBold
	| node root |
	root := self first: '//first**second**third//'.
	self assert: root isItalicNode.
	self assert: root children size = 3.
	
	self assert: root children first isTextNode.
	self assert: root children first text = 'first'.
	self assert: root children third isTextNode.
	self assert: root children third text = 'third'.
	
	node := root children second.
	self assert: node isBoldNode.
	self assert: node children size = 1.
	node := node children first.
	self assert: node isTextNode.
	self assert: node text = 'second'! !

!CreoleParserTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/6/2009 17:04'!
test14BoldWithItalic
	| node root |
	root := self first: '**first//second//third**'.
	self assert: root isBoldNode.
	self assert: root children size = 3.
	
	self assert: root children first isTextNode.
	self assert: root children first text = 'first'.
	self assert: root children third isTextNode.
	self assert: root children third text = 'third'.
	
	node := root children second.
	self assert: node isItalicNode.
	self assert: node children size = 1.
	node := node children first.
	self assert: node isTextNode.
	self assert: node text = 'second'! !

!CreoleParserTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/6/2009 17:29'!
test15ParagraphWithLineBreak
	| node |
	node := self first: 'This is text\with a break' withCRs.
	self assert: node isTextNode.
	self assert: node text = 'This is text with a break'! !

!CreoleParserTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/6/2009 17:36'!
test16ParagraphWithExplicitBreak
	| root node |
	root := self parse: 'one line\\second line'.
	self assert: root isParagraphNode.
	self assert: root children size = 3.
	
	node := root children first.
	self assert: node isTextNode.
	self assert: node text = 'one line'.
	
	node := root children second.
	self assert: node isBreakNode.
	
	node := root children third.
	self assert: node isTextNode.
	self assert: node text = 'second line'.
! !

!CreoleParserTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/6/2009 17:52'!
test17ParagraphWithBackslash
	| root node |
	root := self parse: 'one line\same line'.
	self assert: root isParagraphNode.
	self assert: root children size = 1.
	
	node := root children first.
	self assert: node isTextNode.
	self assert: node text = 'one line\same line'.
	! !

!CreoleParserTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/6/2009 17:54'!
test18Heading1
	| root |
	root := self parse: '= level one heading'.
	self assert: root isHeadingNode.
	self assert: root level = 1.
	self assert: root text = 'level one heading'! !

!CreoleParserTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/6/2009 18:09'!
test19Heading2
	| root |
	root := self parse: '== level two heading'.
	self assert: root isHeadingNode.
	self assert: root level = 2.
	self assert: root text = 'level two heading'! !

!CreoleParserTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/6/2009 18:10'!
test20Heading3
	| root |
	root := self parse: '=== level three heading'.
	self assert: root isHeadingNode.
	self assert: root level = 3.
	self assert: root text = 'level three heading'! !

!CreoleParserTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/6/2009 18:10'!
test21Heading4
	| root |
	root := self parse: '==== level four heading'.
	self assert: root isHeadingNode.
	self assert: root level = 4.
	self assert: root text = 'level four heading'! !

!CreoleParserTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/6/2009 18:11'!
test22Heading5
	| root |
	root := self parse: '===== level five heading'.
	self assert: root isHeadingNode.
	self assert: root level = 5.
	self assert: root text = 'level five heading'! !

!CreoleParserTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/6/2009 18:11'!
test23Heading6
	| root |
	root := self parse: '====== level six heading'.
	self assert: root isHeadingNode.
	self assert: root level = 6.
	self assert: root text = 'level six heading'! !

!CreoleParserTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/6/2009 18:12'!
test24Heading1LeadingSpace
	| root |
	root := self parse: ' = heading'.
	self assert: root isHeadingNode.
	self assert: root level = 1.
	self assert: root text = 'heading'! !

!CreoleParserTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/6/2009 18:21'!
test25Heading1TrailingEquals
	| root |
	root := self parse: ' = heading ='.
	self assert: root isHeadingNode.
	self assert: root level = 1.
	self assert: root text = 'heading'! !

!CreoleParserTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/6/2009 18:21'!
test26Heading1TrailingJunk
	| root |
	root := self parse: ' = heading = foo'.
	self assert: root isHeadingNode.
	self assert: root level = 1.
	self assert: root text = 'heading'! !

!CreoleParserTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/6/2009 18:21'!
test27Heading1Paragraph
	| root node |
	root := self parse: ' = heading\foo' withCRs.
	self assert: root children size = 2.
	
	node := root children first.
	self assert: node isHeadingNode.
	self assert: node level = 1.
	self assert: node text = 'heading'.
	
	node := root children second.
	self assert: node isParagraphNode.
	self assert: node children first text = 'foo'! !

!CreoleParserTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/6/2009 18:22'!
test28Heading1WithMarkup
	| root |
	root := self parse: '= ** not bold **'.
	self assert: root isHeadingNode.
	self assert: root level = 1.
	self assert: root text = '** not bold **'! !

!CreoleParserTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/6/2009 18:22'!
test29Heading1TrailingEquals
	| root |
	root := self parse: ' = heading ======='.
	self assert: root isHeadingNode.
	self assert: root level = 1.
	self assert: root text = 'heading'! !

!CreoleParserTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/6/2009 19:03'!
test30Link
	| root node |
	root := self first: '[[link]]'.
	self assert: root isLinkNode.
	self assert: root reference = 'link'.
	
	node := root label.
	self assert: node isTextNode.
	self assert: node text = 'link'! !

!CreoleParserTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/6/2009 19:04'!
test31LinkWithLabel
	| root node |
	root := self first: '[[reference|label]]'.
	self assert: root isLinkNode.
	self assert: root reference = 'reference'.
	
	node := root label.
	self assert: node isTextNode.
	self assert: node text = 'label'! !

!CreoleParserTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/6/2009 19:10'!
test32LinkWithUrl
	| root node |
	root := self first: '[[http://www.wikicreole.org/]]'.
	self assert: root isLinkNode.
	self assert: root reference = 'http://www.wikicreole.org/'.
	
	node := root label.
	self assert: node isTextNode.
	self assert: node text = 'http://www.wikicreole.org/'! !

!CreoleParserTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/6/2009 19:11'!
test33LinkWithUrlAndLabel
	| root node |
	root := self first: '[[http://www.wikicreole.org/|Visit the WikiCreole website]]'.
	self assert: root isLinkNode.
	self assert: root reference = 'http://www.wikicreole.org/'.
	
	node := root label.
	self assert: node isTextNode.
	self assert: node text = 'Visit the WikiCreole website'! !

!CreoleParserTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/6/2009 19:13'!
test34BoldLink
	| root node |
	root := self first: '**[[link]]**'.
	self assert: root isBoldNode.
	self assert: root children size = 1.
	
	node := root children first.
	self assert: node isLinkNode.
	self assert: node reference = 'link'.
	
	node := node label.
	self assert: node isTextNode.
	self assert: node text = 'link'! !

!CreoleParserTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/6/2009 19:21'!
test35ItalicLink
	| root node |
	root := self first: '//[[link]]//'.
	self assert: root isItalicNode.
	self assert: root children size = 1.
	
	node := root children first.
	self assert: node isLinkNode.
	self assert: node reference = 'link'.
	
	node := node label.
	self assert: node isTextNode.
	self assert: node text = 'link'! !

!CreoleParserTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/7/2009 00:42'!
test36PararaphWithLink
	| root |
	root := self parse: 'first[[second]]third'.
	self assert: root isParagraphNode..
	self assert: root children size = 3.
	
	self assert: root children first isTextNode.
	self assert: root children second isLinkNode.
	self assert: root children third isTextNode.! !

!CreoleParserTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/7/2009 00:47'!
test37OneBulletList
	| root node |
	root := self parse: '* item'.
	self assert: root isUnorderedListNode.
	self assert: root children size = 1.
	
	node := root children first.
	self assert: node isItemNode.
	self assert: node children size = 1.
	
	node := node children first.
	self assert: node isTextNode.
	self assert: node text = 'item'
	! !

!CreoleParserTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/7/2009 01:31'!
test38TwoBulletList
	| root node |
	root := self parse: '* item1\* item2' withCRs.
	self assert: root isUnorderedListNode.
	self assert: root children size = 2.
	
	node := root children first.
	self assert: node isItemNode.
	self assert: node children size = 1.
	
	node := node children first.
	self assert: node isTextNode.
	self assert: node text = 'item1'.
	
	node := root children second.
	self assert: node isItemNode.
	self assert: node children size = 1.
	
	node := node children first.
	self assert: node isTextNode.
	self assert: node text = 'item2'

	
	! !

!CreoleParserTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/7/2009 01:54'!
test39BulletWithBold
	| root node |
	root := self parse: '* **item**'.
	self assert: root isUnorderedListNode.
	self assert: root children size = 1.
	node := root children first.
	self assert: node isItemNode.
	self assert: node children size = 1.
	node := node children first.
	self assert: node isBoldNode.
	self assert: node children size = 1.
	node := node children first.
	self assert: node isTextNode.
	self assert: node text = 'item'! !

!CreoleParserTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/7/2009 01:54'!
test40BulletWithItalics
	| root node |
	root := self parse: '* //item//'.
	self assert: root isUnorderedListNode.
	self assert: root children size = 1.
	node := root children first.
	self assert: node isItemNode.
	self assert: node children size = 1.
	node := node children first.
	self assert: node isItalicNode.
	self assert: node children size = 1.
	node := node children first.
	self assert: node isTextNode.
	self assert: node text = 'item'! !

!CreoleParserTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/7/2009 01:57'!
test41BulletWithBreak
	| root node item |
	root := self parse: '* one\\two'.
	self assert: root isUnorderedListNode.
	self assert: root children size = 1.
	
	item := root children first.
	self assert: item isItemNode.
	self assert: item children size = 3.
	
	node := item children first.
	self assert: node isTextNode.
	self assert: node text = 'one'.
	
	node := item children second.
	self assert: node isBreakNode.
	
	node := item children third.
	self assert: node isTextNode.
	self assert: node text = 'two'
	! !

!CreoleParserTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/7/2009 01:58'!
test42BulletWithCR
	| root node |
	root := self parse: '* one\two' withCRs.
	self assert: root isUnorderedListNode.
	self assert: root children size = 1.
	
	node := root children first.
	self assert: node isItemNode.
	self assert: node children size = 1.
	
	node := node children first.
	self assert: node isTextNode.
	self assert: node text = 'one two'
	! !

!CreoleParserTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/7/2009 10:17'!
test43NestedList
	| root node item |
	root := self parse: '* one\** two' withCRs.
	self assert: root isUnorderedListNode.
	self assert: root children size = 1.
	
	item := root children first.
	self assert: item isItemNode.
	self assert: item children size = 2. 
	
	node := item children first.
	self assert: node isTextNode.
	self assert: node text = 'one'.
	
	node := item children second.
	self assert: node isUnorderedListNode.
	self assert: node children size = 1.
	
	node := node children first.
	self assert: node isItemNode.
	self assert: node children size = 1.

	node := node children first.
	self assert: node isTextNode.
	self assert: node text = 'two'
	! !

!CreoleParserTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/7/2009 10:25'!
test44ItemAfterNestedList
	| root node item |
	root := self parse: '* one\** two\* three' withCRs.
	self assert: root isUnorderedListNode.
	self assert: root children size = 2.
	
	item := root children second.
	self assert: item isItemNode.
	self assert: item children size = 1. 
		
	node := item children first.
	self assert: node isTextNode.
	self assert: node text = 'three'
	! !

!CreoleParserTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/7/2009 10:33'!
test45OrderedList
	| root node item |
	root := self parse: '# one' withCRs.
	self assert: root isOrderedListNode.
	self assert: root children size = 1.
	
	item := root children first.
	self assert: item isItemNode.
	self assert: item children size = 1. 
		
	node := item children first.
	self assert: node isTextNode.
	self assert: node text = 'one'
	! !

!CreoleParserTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/7/2009 10:41'!
test46MixedNestedList
	| root node item |
	root := self parse: '* one\## two' withCRs.
	self assert: root isUnorderedListNode.
	self assert: root children size = 1.
	
	item := root children first.
	self assert: item isItemNode.
	self assert: item children size = 2. 
	
	node := item children first.
	self assert: node isTextNode.
	self assert: node text = 'one'.
	
	node := item children second.
	self assert: node isOrderedListNode.
	self assert: node children size = 1.
	
	node := node children first.
	self assert: node isItemNode.
	self assert: node children size = 1.

	node := node children first.
	self assert: node isTextNode.
	self assert: node text = 'two'
	! !

!CreoleParserTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/7/2009 11:18'!
test47NestedOrderedList
	| root node item |
	root := self parse: '# one\## two' withCRs.
	self assert: root isOrderedListNode.
	self assert: root children size = 1.
	
	item := root children first.
	self assert: item isItemNode.
	self assert: item children size = 2. 
	
	node := item children first.
	self assert: node isTextNode.
	self assert: node text = 'one'.
	
	node := item children second.
	self assert: node isOrderedListNode.
	self assert: node children size = 1.
	
	node := node children first.
	self assert: node isItemNode.
	self assert: node children size = 1.

	node := node children first.
	self assert: node isTextNode.
	self assert: node text = 'two'
	! !

!CreoleParserTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/7/2009 11:20'!
test48Rule
	| root |
	root := self parse: '----'.
	self assert: root isRuleNode.
	! !

!CreoleParserTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/7/2009 11:27'!
test49RuleWithLeadingSpaces
	| root |
	root := self parse: '  ----'.
	self assert: root isRuleNode.
	! !

!CreoleParserTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/7/2009 11:27'!
test50RuleWithTrailingSpaces
	| root |
	root := self parse: '----  '.
	self assert: root isRuleNode.
	! !

!CreoleParserTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/7/2009 11:38'!
test51RuleWithTrailingCharacters
	| root |
	root := self parse: '----  xxx'.
	self assert: root isParagraphNode
	! !

!CreoleParserTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/7/2009 11:41'!
test52Image
	| root |
	root := self first: '{{reference}}'.
	self assert: root isImageNode.
	self assert: root reference = 'reference'.
	! !

!CreoleParserTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/10/2009 21:07'!
test53ImageWithAltText
	| root |
	root := self first: '{{reference|alt}}'.
	self assert: root isLinkNode.
	self assert: root reference = 'reference'.
	
	self assert: root label = 'alt'! !

!CreoleParserTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/10/2009 21:09'!
test54LinkedImage
	| root node |
	root := self first: '[[reference|{{image.png|alt}}]]'.
	self assert: root isLinkNode.
	self assert: root reference = 'reference'.
	
	node := root label.
	self assert: node isImageNode.
	self assert: node reference = 'image.png'.
	
	self assert: node label = 'alt'! !

!CreoleParserTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/10/2009 21:09'!
test55LinkWithTextAndImage
	| root node label |
	root := self first: '[[ reference | one {{image.png|alt}} two]]'.
	self assert: root isLinkNode.
	self assert: root reference = 'reference'.
	
	label := root label.
	self assert: label children size = 3.
	
	node := label children first.
	self assert: node isTextNode.
	self assert: node text = 'one '.
	
	node := label children second.
	self assert: node isImageNode.
	self assert: node reference = 'image.png'.
	self assert: node label = 'alt'.
	
	node := label children third.
	self assert: node isTextNode.
	self assert: node text = ' two'! !

!CreoleParserTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/10/2009 21:09'!
test56TextWithImage
	| root node |
	root := self parse: 'one {{image.png|alt}} two'.
	self assert: root children size = 3.
	
	node := root children first.
	self assert: node isTextNode.
	self assert: node text = 'one '.
	
	node := root children second.
	self assert: node isImageNode.
	self assert: node reference = 'image.png'.
	self assert: node label = 'alt'.
	
	node := root children third.
	self assert: node isTextNode.
	self assert: node text = ' two'! !

!CreoleParserTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/7/2009 13:16'!
test57NowikiInline
	| root node |
	root := self parse: 'one {{{ ** not bold ** }}} two'.
	self assert: root children size = 3.
	
	node := root children first.
	self assert: node isTextNode.
	self assert: node text = 'one '.
	
	node := root children third.
	self assert: node isTextNode.
	self assert: node text = ' two'.
	
	node := root children second.
	self assert: node isInlineNowikiNode.
	self assert: node text = ' ** not bold ** '
	
! !

!CreoleParserTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/7/2009 13:53'!
test58NowikiInlineWithBraces
	| root node |
	root := self parse: 'one {{{{ ** not bold ** }}}} two'.
	self assert: root children size = 3.
	
	node := root children first.
	self assert: node isTextNode.
	self assert: node text = 'one '.
	
	node := root children third.
	self assert: node isTextNode.
	self assert: node text = ' two'.
	
	node := root children second.
	self assert: node isInlineNowikiNode.
	self assert: node text = '{ ** not bold ** }'
	
! !

!CreoleParserTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/7/2009 14:15'!
test59NowikiInlineWithBrace
	| root node |
	root := self parse: 'one {{{ 1 {2} 3 }}} two'.
	self assert: root children size = 3.
	
	node := root children first.
	self assert: node isTextNode.
	self assert: node text = 'one '.
	
	node := root children third.
	self assert: node isTextNode.
	self assert: node text = ' two'.
	
	node := root children second.
	self assert: node isInlineNowikiNode.
	self assert: node text = ' 1 {2} 3 '
	
! !

!CreoleParserTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/7/2009 17:26'!
test60NowikiBlock
	| root node |
	root := self parse: 'one\{{{\ ** not bold ** \}}}\two' withCRs.
	self assert: root children size = 3.
	self assert: root children first isParagraphNode.
	self assert: root children third isParagraphNode.
	
	node := root children second.
	self assert: node isBlockNowikiNode.
	self assert: node text = ' ** not bold ** \' withCRs
	
! !

!CreoleParserTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/7/2009 18:13'!
test61BoldOnNewLine
	| root node |
	root := self parse: 'one\** bold **\two' withCRs.
	self assert: root children size = 3.
	self assert: root children first isTextNode.
	self assert: root children third isTextNode.
	
	node := root children second.
	self assert: node isBoldNode.
	self assert: node children size = 1.
	
	node := node children first.
	self assert: node isTextNode.
	self assert: node text = ' bold '
	
! !

!CreoleParserTest methodsFor: 'tests' stamp: 'cwp 1/7/2009 21:29'!
test62Table
	| root node |
	root := self parse: '| cell |'.
	self assert: root isTableNode.
	self assert: root children size = 1.
	
	node := root children first.
	self assert: node isRowNode.
	self assert: node children size = 1.
	
	node := node children first.
	self assert: node isCellNode.
	self assert: node children size = 1.
	
	node := node children first.
	self assert: node isTextNode.
	self assert: node text = ' cell '! !

!CreoleParserTest methodsFor: 'tests' stamp: 'cwp 1/7/2009 21:32'!
test63TableTwoCells
	| root node |
	root := self parse: '| cell1 | cell2 |'.
	self assert: root isTableNode.
	self assert: root children size = 1.
	
	node := root children first.
	self assert: node isRowNode.
	self assert: node children size = 2.
	
	node := node children first.
	self assert: node isCellNode.
	self assert: node children size = 1.
	
	node := node children first.
	self assert: node isTextNode.
	self assert: node text = ' cell1 '.
	
	node := root children first children second.
	self assert: node isCellNode.
	self assert: node children size = 1.	
	
	node := node children first.
	self assert: node isTextNode.
	self assert: node text = ' cell2 '! !

!CreoleParserTest methodsFor: 'tests' stamp: 'cwp 1/7/2009 21:34'!
test64Table2x2
	| root node |
	root := self parse: '| cell1 | cell2 |\| cell3 | cell 4 |' withCRs.
	
	self assert: root isTableNode.
	self assert: root children size = 2.
	
	node := root children second.
	self assert: node isRowNode.
	self assert: node children size = 2.
	
	node := node children first.
	self assert: node isCellNode.
	self assert: node children size = 1.
	
	node := node children first.
	self assert: node isTextNode.
	self assert: node text = ' cell3 '.
	
! !

!CreoleParserTest methodsFor: 'tests' stamp: 'cwp 1/7/2009 21:34'!
test65RowWithTrailingSpaces
	| root node |
	root := self parse: '| cell1 | cell2 |  \| cell3 | cell 4 |' withCRs.
	
	self assert: root isTableNode.
	self assert: root children size = 2.
	
	node := root children second.
	self assert: node isRowNode.
	self assert: node children size = 2.
	
	node := node children first.
	self assert: node isCellNode.
	self assert: node children size = 1.
	
	node := node children first.
	self assert: node isTextNode.
	self assert: node text = ' cell3 '.
	
! !

!CreoleParserTest methodsFor: 'tests' stamp: 'cwp 1/7/2009 21:53'!
test66RowWithLeadingSpaces
	| root node |
	root := self parse: '| cell1 | cell2 |\  | cell3 | cell 4 |' withCRs.
	
	self assert: root isTableNode.
	self assert: root children size = 2.
	
	node := root children second.
	self assert: node isRowNode.
	self assert: node children size = 2.
	
	node := node children first.
	self assert: node isCellNode.
	self assert: node children size = 1.
	
	node := node children first.
	self assert: node isTextNode.
	self assert: node text = ' cell3 '.
	
! !

!CreoleParserTest methodsFor: 'tests' stamp: 'cwp 1/7/2009 21:56'!
test67TableWithLink
	| root node |
	root := self parse: '|[[link]]|'.
	self assert: root isTableNode.
	self assert: root children size = 1.
	
	node := root children first children first children first.
	self assert: node isLinkNode.
	self assert: node reference = 'link'! !

!CreoleParserTest methodsFor: 'tests' stamp: 'cwp 1/7/2009 22:03'!
test68TableWithBold
	| root node |
	root := self parse: '|**bold**|'.
	self assert: root isTableNode.
	self assert: root children size = 1.
	
	node := root children first children first children first.
	self assert: node isBoldNode.
	self assert: node children size = 1.
	
	node := node children first.
	self assert: node isTextNode.
	self assert: node text = 'bold'! !

!CreoleParserTest methodsFor: 'tests' stamp: 'cwp 1/7/2009 22:04'!
test69TableWithItalics
	| root node |
	root := self parse: '|//bold//|'.
	self assert: root isTableNode.
	self assert: root children size = 1.
	
	node := root children first children first children first.
	self assert: node isItalicNode.
	self assert: node children size = 1.
	
	node := node children first.
	self assert: node isTextNode.
	self assert: node text = 'bold'! !

!CreoleParserTest methodsFor: 'tests' stamp: 'cwp 1/7/2009 22:07'!
test70TableWithBreak
	| root node |
	root := self parse: '|one\\two|'.
	self assert: root isTableNode.
	self assert: root children size = 1.
	
	node := root children first children first.
	self assert: node children size = 3.
	
	node := node children second.
	self assert: node isBreakNode! !

!CreoleParserTest methodsFor: 'tests' stamp: 'cwp 1/7/2009 22:11'!
test71TableWithNowiki
	| root node |
	root := self parse: '|{{{ ** nowiki ** }}}|'.
	self assert: root isTableNode.
	self assert: root children size = 1.
	
	node := root children first children first.
	self assert: node children size = 1.
	
	node := node children first.
	self assert: node isInlineNowikiNode.
	self assert: node text = ' ** nowiki ** '.! !

!CreoleParserTest methodsFor: 'tests' stamp: 'cwp 1/7/2009 23:00'!
test72TableWithHeader
	| root node |
	root := self parse: '|= header |'.
	self assert: root isTableNode.
	self assert: root children size = 1.
	
	node := root children first children first.
	self assert: node children size = 1.
	self assert: node isCellNode.
	self assert: node isHeader.
	! !

!CreoleParserTest methodsFor: 'tests' stamp: 'cwp 1/8/2009 11:54'!
test73BoldEscape
	| root node |
	root := self parse: '~** not bold'.
	self assert: root isParagraphNode.
	self assert: root children size = 1.
	
	node := root children first.
	self assert: node isTextNode.
	self assert: node text = '** not bold'! !

!CreoleParserTest methodsFor: 'tests' stamp: 'cwp 1/8/2009 11:57'!
test74ItalicsEscape
	| root node |
	root := self parse: '~// plain'.
	self assert: root isParagraphNode.
	self assert: root children size = 1.
	
	node := root children first.
	self assert: node isTextNode.
	self assert: node text = '// plain'! !

!CreoleParserTest methodsFor: 'tests' stamp: 'cwp 1/8/2009 11:57'!
test75LinkEscape
	| root node |
	root := self parse: '~[[ plain'.
	self assert: root isParagraphNode.
	self assert: root children size = 1.
	
	node := root children first.
	self assert: node isTextNode.
	self assert: node text = '[[ plain'! !

!CreoleParserTest methodsFor: 'tests' stamp: 'cwp 1/8/2009 11:58'!
test76ImageEscape
	| root node |
	root := self parse: '~{{ plain'.
	self assert: root isParagraphNode.
	self assert: root children size = 1.
	
	node := root children first.
	self assert: node isTextNode.
	self assert: node text = '{{ plain'! !

!CreoleParserTest methodsFor: 'tests' stamp: 'cwp 1/8/2009 12:00'!
test77BreakEscape
	| root node |
	root := self parse: '~\\ plain'.
	self assert: root isParagraphNode.
	self assert: root children size = 1.
	
	node := root children first.
	self assert: node isTextNode.
	self assert: node text = '\\ plain'! !

!CreoleParserTest methodsFor: 'tests' stamp: 'cwp 1/8/2009 12:03'!
test78NowikiEscape
	| root node |
	root := self parse: '~{{{image.png}}'.
	self assert: root isParagraphNode.
	self assert: root children size = 2.
	
	node := root children first.
	self assert: node isTextNode.
	self assert: node text = '{'.
	
	node := root children second.
	self assert: node isImageNode.
! !

!CreoleParserTest methodsFor: 'tests' stamp: 'cwp 1/8/2009 12:11'!
test79UnorderedListEscape
	| root node |
	root := self parse: 'one\~* not a list' withCRs.
	self assert: root isParagraphNode.
	self assert: root children size = 1.
	
	node := root children first.
	self assert: node isTextNode.
	self assert: node text = 'one * not a list'.
	
! !

!CreoleParserTest methodsFor: 'tests' stamp: 'cwp 1/8/2009 12:08'!
test80HeaderEscape
	| root node |
	root := self parse: 'one\~= not a header' withCRs.
	self assert: root isParagraphNode.
	self assert: root children size = 1.
	
	node := root children first.
	self assert: node isTextNode.
	self assert: node text = 'one = not a header'.
	
! !

!CreoleParserTest methodsFor: 'tests' stamp: 'cwp 1/8/2009 12:11'!
test81OrderedListEscape
	| root node |
	root := self parse: 'one\~# plain' withCRs.
	self assert: root isParagraphNode.
	self assert: root children size = 1.
	
	node := root children first.
	self assert: node isTextNode.
	self assert: node text = 'one # plain'.
	
! !

!CreoleParserTest methodsFor: 'tests' stamp: 'cwp 1/8/2009 12:12'!
test82RuleEscape
	| root node |
	root := self parse: 'one\~---- plain' withCRs.
	self assert: root isParagraphNode.
	self assert: root children size = 1.
	
	node := root children first.
	self assert: node isTextNode.
	self assert: node text = 'one ---- plain'.
	
! !

!CreoleParserTest methodsFor: 'tests' stamp: 'cwp 1/8/2009 12:24'!
test83NowikiEscape
	| root node |
	root := self parse: 'one\~{{{\plain}}}\two' withCRs.
	self assert: root isParagraphNode.
	self assert: root children size = 3.
	
	node := root children second.
	self assert: node isImageNode
! !

!CreoleParserTest methodsFor: 'tests' stamp: 'cwp 1/8/2009 12:31'!
test84TableEscape
	| root node |
	root := self parse: 'one\~| plain' withCRs.
	self assert: root isParagraphNode.
	self assert: root children size = 1.
	
	node := root children first.
	self assert: node isTextNode.
	self assert: node text = 'one | plain' 
! !
